-----view start
--viewHeight=res_h/4
--viewWidth=res_w/4




function ingameDraw ()	
   	LG.setFont (gFont.small)
	
   	drawLevel (0,20,0,20)
   	printAllPlayers (800,20)
  -- 	drawPlayers ()
   	drawUnits ()

   	if splitScreen then
		for i=1, #views do
			drawView(views[i])
		end
		--drawView(view1)
		--drawView(view2)
		--drawView(mouseView)
		--for i=1,#views do
			showView(views[1], 0,0, "ONE")
			showView(views[2], res_w/2,0, "TWO")
			showView(views[3], 0,res_h/2, "THREE")
			showView(views[4], res_w/2,res_h/2, "FOUR")
			
		--end
		--showView(view2, res_w/2,0, "player 2 TWO")
		--showView(mouseView, 0,res_h-270, "look at mouse")
	end
	
	--love.graphics.print("ig_draw() gt:"..gt, 10, 30)
  -- 	love.graphics.print("ig_draw() gbla:"..gbla, 10, 50)
end

function ingameUpdate (dt)
	gbla=math.random(100)
	getPlayersInputs()
	updatePlayersPhysics3 (dt)
	updateUnitsWant ()
	updateUnitsPhysics (dt)
	views[1].cameraX = gunits[gplayers[1].controllsUnit].x
	views[1].cameraY = gunits[gplayers[1].controllsUnit].y
	views[2].cameraX = gunits[26].x --gplayers[2].x--+math.sin (gplayers[2].angle)*100
	views[2].cameraY = gunits[26].y--gplayers[2].y--+math.cos (gplayers[2].angle)*100
	
	views[3].cameraX = level.tWidth*TILESIZE/2+math.sin (gt/4)*500
	views[3].cameraY = level.tWidth*TILESIZE/2+math.cos (gt/4)*500

	local mx,my = TLfres.getMousePosition(res_w,res_h)
	mouseView.cameraX=mx
	mouseView.cameraY=my
end

function ingameKeyPressed (key, unicode)
	if key == "escape" then changeGameStatus ("menu") end
	if key == "space" then splitScreen = not splitScreen end
	if key == "m" then 
		local mx,my = TLfres.getMousePosition(res_w,res_h)
		level.tile[world2tile(mx)][world2tile(my)].block=true
	end
	if key=="tab" then setUnitControllToPlayer (rnd(1,#gunits), 1) end
end


function updatePlayersPhysics3 (dt)
	local speed = 5
	local m=speed*dt

	for i,p in ipairs(gplayers) do
		--always update which tile player is on
		p.tx=world2tile(p.x)
		p.ty=world2tile(p.y)
		
		p.tox=p.tx
		p.toy=p.ty
		local newx=p.x	--newx/newy used for checking collision. if okay, then x=newx
		local newy=p.y
		local dirx=0
		local diry=0
		local wx=0		--atm not needed for physics. maybe later for animation?
		local wy=0
		--[[ pacman style, works
		if p.wantLeft then dirx=-1 wx=true end
		if p.wantRight then dirx=1 wy=true end
		if p.wantUp then diry=-1 wy=true end
		if p.wantDown then diry=1 wy=true end	
		if p.wantLeft then p.tox = p.tx-1 wx=true end
		if p.wantRight then p.tox = p.tx+1 wy=true end
		if p.wantUp then p.toy = p.ty-1 wy=true end
		if p.wantDown then p.toy = p.ty+1 wy=true end	
		newx=p.x+dirx*m
		newy=p.y+diry*m
		--]]
		--[[car style, works
		if p.wantLeft then p.angle=p.angle+3*dt end
		if p.wantRight then p.angle=p.angle-3*dt end
		if p.wantUp then dirx=sin(p.angle)  diry=cos(p.angle) end
		if p.wantDown then dirx=sin(p.angle)  diry=cos(p.angle) end
		if p.wantUp then
			newx=p.x+dirx*m
			newy=p.y+diry*m
		end
		if p.wantDown then
			newx=p.x-dirx*m
			newy=p.y-diry*m
		end
		--]]
		if p.wantLeft then p.angle=p.angle+4*dt end
		if p.wantRight then p.angle=p.angle-4*dt end
		local newxs=p.xs
		local newys=p.ys
		if p.ty > 100 then newys=newys+(dt*5) end	--gravity
		if p.wantUp then
			newxs=p.xs+sin(p.angle)*m
			newys=p.ys+cos(p.angle)*m
		end
		
		newx=p.x+newxs
		newy=p.y+newys

		-----collission:
		local allowX=false
		local allowY=false
		--check corners of player
		if not colCornersCheckBlock (level, newx,p.y,PLAYERRADIUS) then
			allowX=true
		end
		if not colCornersCheckBlock (level, p.x,newy,PLAYERRADIUS) then
			allowY=true
		end  
		--anti-stuck: ist auf freiem tile aber hängt mit einer ecke in wand
		if not allowX and not allowY and not isBlock(level, p.tx, p.ty) and abs(p.xs)<0.1 and abs(p.ys)<0.1 then
			p.x = tile2world (p.tx)
			p.y = tile2world (p.ty)
			dbgtxt=dbgtxt.."antistuck!"
		end
		
		if allowX then p.x=newx  p.xs=newxs else p.xs=-p.xs/20 end
		if allowY then p.y=newy  p.ys=newys else p.ys=-p.ys/20 end
		
		
		--end
		
		--end
	end
end

--returns true if any of the 4 corners of an object at x:y with sidelenght a
--is intersecting with a blocking tile
function colCornersCheckBlock (level, x,y, a)
	local cornerLT = isBlock(level, world2tile (x-a),world2tile(y-a))
	local cornerRT = isBlock(level, world2tile (x+a),world2tile(y-a))
	local cornerLB = isBlock(level, world2tile (x-a),world2tile(y+a))
	local cornerRB = isBlock(level, world2tile (x+a),world2tile(y+a))
	return cornerLT or cornerRT or cornerLB or cornerRB
end

function loadLevel (levelnumber)
	levelData = "xxx xxx"
	level = {}
	level.tWidth=300
	level.tHeight=300
	level.trees = {}
	for i = 1, 1000 do
		level.trees[i]= {x=math.random(0,32*50), y=math.random (0,32*50), size = math.random (5,20)}
	end
	level.tile = {}
	for x = 0, level.tWidth, 1 do  --TEST
		level.tile[x]={}
		for y = 0, level.tHeight, 1 do			
			local c = {rnd(2,50)/100,rnd(80,100)/100,rnd(20,50)/100}
			if y < 100 then c={rnd(80,100)/100,rnd(80,100)/100,rnd(20,50)/100} end
			level.tile[x][y] = {block = false , color=c }
			if x==0 or y==0 or x==level.tWidth or y==level.tHeight then level.tile[x][y].block = true end

		end
	end
	
	for i =1,500,1 do
		local a=3
		local x=rnd(0+a,level.tWidth-a)
		local y=rnd(0+a,level.tHeight-a)
		for n=0,20,1 do
			level.tile[x+rnd(-a,a)][y+rnd(-a,a)].block=true
		end
	--if rnd(0,100) > 90 then b=true end
	end
	
	
end

function isBlock (level, tx,ty)
	return level.tile[tx][ty].block
end


function drawLevel (xstart,xend,ystart,yend)
	local xstart=xstart or 0
	local xend=xend or level.tWidth
	local ystart=ystart or 0
	local yend=yend or level.tHeight
	for x = math.max(0,xstart),math.min(xend,level.tWidth),1  do
		for y = math.max(0,ystart), math.min(yend,level.tHeight), 1 do
			local dx=x*TILESIZE
			local dy=y*TILESIZE	
			if (level.tile[x][y].block==true) then 
				LG.setColor (level.tile[x][y].color[1],level.tile[x][y].color[2],level.tile[x][y].color[3])
		--		LG.setColor (0.1,0.1,0.1,1)
				LG.rectangle ("fill", dx-TILESIZE/2,dy-TILESIZE/2, TILESIZE,TILESIZE)
			else
				LG.setColor (1,0,0.5,0.2)
				LG.rectangle ("line", dx-TILESIZE/2,dy-TILESIZE/2, TILESIZE,TILESIZE)
			end


		end
	end

--	for i =1, #level.trees do
--		drawTree (level.trees[i].x, level.trees[i].y, level.trees[i].size)
--	end
	local mx,my = TLfres.getMousePosition(res_w,res_h)
	LG.setColor (1,1,0,1)
	for r = 10, 10+math.abs(math.sin (gt*10))*50, 10 do
		LG.circle ("line", mx,my, r, 8)
	end
		LG.setColor (1,0,0,1)

	
	LG.line (50,50,200+math.sin(gt)*100,200)
	
	LG.circle("line",tile2world (0), tile2world (0), 10, 10)
	LG.circle("line",tile2world (1), tile2world (1), 10, 10)


end

function drawTree (x,y,size)
	LG.setColor(0, 1, 0, 1)	
	LG.circle("fill", x,y, size, 3)
end

function drawPlayers ()
	LG.setColor(1, 1, 0, 1)
	LG.print ("drawPlayers()",500,20)

	for i,p in ipairs(gplayers) do
			--	LG.circle("fill", 500,50+i*50, 100, 4)
			LG.setColor(1, 1, 1, 1)
			drawShip (p.x, p.y, p.angle, PLAYERRADIUS)
			
		--	if p.wantUp then 
		--	local l = rnd (2,8)
		--	local ar = rnd(-4,4)/40
		--	LG.line (p.x+sin(p.angle)*PLAYERRADIUS*-1, p.y+cos(p.angle)*PLAYERRADIUS*-1,
		--	p.x+sin(p.angle+ar)*PLAYERRADIUS*-l, p.y+cos(p.angle+ar)*PLAYERRADIUS*-l) end

			--LG.circle("line", p.x,p.y, PLAYERRADIUS, 4)
--debug:
			--LG.print ("player"..i,p.x,p.y)
		--	local dx=500
	--		local dy=500
		--	LG.print ("player iXY:" .. i.." / ".. p.x.." / ".. p.y, dx,dy+20+i*60)
			
		--	LG.print ("player tileXY:" .. i.." / ".. p.tx.." / ".. p.ty, dx,dy+i*60)
			
			
			if debug then			
			LG.setColor (1,0,0,1)
			LG.circle("line",tile2world (p.tx), tile2world (p.ty), PLAYERRADIUS, 4)
			LG.circle("line",tile2world (p.tox), tile2world (p.toy), PLAYERRADIUS, 6)
			LG.setColor(1, rnd(0,10)/10, 0, 1)
			LG.rectangle ("line", p.x-PLAYERRADIUS, p.y-PLAYERRADIUS,   PLAYERRADIUS*2, PLAYERRADIUS*2)  
			LG.setColor(1, rnd(0,10)/10, 0, 0.5)
			LG.rectangle ("fill",tile2world(p.tox)-(TILESIZE/2), tile2world(p.toy)-(TILESIZE/2), TILESIZE,TILESIZE)
			LG.line (p.x,p.y,p.x+math.sin(p.angle)*PLAYERRADIUS*2, p.y+math.cos(p.angle)*PLAYERRADIUS*2)

			end
	end
end


function drawShip (x,y, a, want, r)
    local r = r or PLAYERRADIUS
    local want = want or {}
	a=a+math.pi
	--love.graphics.setColor(0, 255, 150, 255)
	--love.graphics.setColor(255, 255, 50, 255)
	--love.graphics.setLine(3) --pre 0.9.2
	love.graphics.setLineWidth(3)
	local p1x = (x-sin(a)*r) -- obere Spitze
	local p1y=(y-cos(a)*r)
	   local p2x= (x+sin(a)*r/2)--unteres Ende
	   local p2y=(y+cos(a)*r/2)
	local p3x= (x+sin(a-0.8)*r)--- linke Flügelspitze
	local p3y= (y+cos(a-0.8)*r)
	   local p4x= (x+sin(a+0.8)*r)-- rechte Flügelspitze
	   local p4y= (y+cos(a+0.8)*r)
	love.graphics.line (p1x,p1y, p4x,p4y)
	love.graphics.line (p1x,p1y, p3x,p3y)
	love.graphics.line (p4x,p4y, p2x,p2y)
	love.graphics.line (p3x,p3y, p2x,p2y)
	
	
	if want.up then 
		local l = rnd (2,8)
		local ar = rnd(-4,4)/40
		LG.line (x+sin(a)*PLAYERRADIUS*1,y+cos(a)*PLAYERRADIUS*1,
		x+sin(a+ar)*PLAYERRADIUS*l, y+cos(a+ar)*PLAYERRADIUS*l)
	end
	
 end
 
 
 function drawPacman (x,y, a, want, r)
    local r = r or PLAYERRADIUS
	--a=gt
	--a=a-math.pi
	--LG.setColor (0,0,1,1)
	--LG.circle ("fill", x,y,r,10)
	LG.setColor (1,1,0,1)
	--LG.circle ("line", x,y,r*abs(sin(gt)),10)
	mouth = abs(sin(gt*10))/2
	local d = math.pi/2
	local a1=mouth-a+d
	local a2=(math.pi * 2) - mouth-a+d
	
	--if a1>a2 then a1,a2=a2,a1 end
	love.graphics.arc( "fill", x, y, r, a1, a2 )
	--drawShip (x,y+20,a)
 end
 
 function blabla()
 end
 

 
 
