BH= require("bibhandgemalt")
--BH.on()
LKB = love.keyboard
LG = love.graphics
rnd = math.random
sin = math.sin
cos = math.cos
abs = math.abs
gbla = 100 
gGame = {status="load"}	--status:ingame/menu
gt = 0
gplayers = {}
gunits = {}

dbgtxt = ""
debug = false
res_w = 1280
res_h = 768
level = {}
TILESIZE = 32
PLAYERRADIUS = 14
require "other"

TLfres = require "tlfres"
require "ingame"
require "menu"
require "game"
require "players"
require "units"
require "clickbuttons"
require "view"
require "runlogger"
--FIXME: views nicht auflösungsunabhängig definiert
views = {}
for i = 1,4 do
	views[i] = newView (res_w/2, res_h/2, "view"..i) --{ canvas = love.graphics.newCanvas(res_w/4, res_h/4) }
--view2 = newView (res_w/2, res_h/2, "view2") --{ canvas = love.graphics.newCanvas(res_w/4, res_h/4) }
end
mouseView = newView (res_w, 250, "mouseView") --{ canvas = love.graphics.newCanvas(res_w/4, res_h/4) }


gFont = {}
gFont.small = LG.newFont("november.regular.ttf", 14 )
gFont.normal = LG.newFont("november.regular.ttf", 18 )



function love.load ()
	logRun("handgemalt test")
	print "love.load()"
	menuLoad ()
	love.window.setMode (res_w, res_h, {fullscreen=true})
	loadLevel (1)
	addPlayer ("a","d","w","s","x")
	addPlayer ("j","l","i","k",",")
	for i=1,500 do
		addUnit (rnd(1,level.tWidth) ,rnd(4,level.tHeight))
		if i < 25 then
			gunits[i].movementFunction=movementPacman
			gunits[i].drawFunction=drawPacman

		else
			gunits[i].movementFunction=movementSpaceship
			gunits[i].drawFunction=drawShip
		end
	end
	setUnitControllToPlayer (4,1)
	changeGameStatus ("ingame")
end

function love.update(dt)
	gt=gt+dt
	if gGame.status == "ingame" then ingameUpdate (dt) end
	if gGame.status == "menu" then menuUpdate (dt) end
end
    
function love.draw()
	love.graphics.push()
	TLfres.beginRendering(res_w, res_h,false)
	--love.graphics.setColor(1,0.5, 1, 1)
	love.graphics.setColor(0, 0, 1, 1)
	love.graphics.rectangle ("line", 0, 0, res_w, res_h)
	LG.setFont (gFont.small)
   	if gGame.status == "ingame" then ingameDraw () end
   	if gGame.status == "menu" then menuDraw () end
	love.graphics.setColor(1, 0, 1, 1)
	love.graphics.print("FPS: "..tostring(love.timer.getFPS( )), res_w-50, res_h-15)
	LG.print("player1: asdw  player2:jlik  space:toggle splitscreens", 0, res_h-30)
	if debug then LG.print("dbgtxt:"..dbgtxt, 30, 30) end

	gstats = love.graphics.getStats()
    gstats.texturememoryMB  = gstats.texturememory / 1024 / 1024
    love.graphics.print(dump(gstats), 0, 500)

	TLfres.endRendering({0.1,0,0.1})
	love.graphics.pop()
end

function love.keypressed(key, unicode)
	if gGame.status == "ingame" then ingameKeyPressed (key,unicode) return end
	if gGame.status == "menu" then menuKeyPressed (key,unicode) return end
end

--function love.graphics.print()
--end
