
--http://lua-users.org/wiki/CopyTable
function shallowcopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in pairs(orig) do
            copy[orig_key] = orig_value
        end
    else -- number, string, boolean, etc
        copy = orig
    end
    return copy
end


--https://stackoverflow.com/questions/9168058/how-to-dump-a-table-to-console
function dump(o)
   if type(o) == 'table' then
      local s = '{ '
      for k,v in pairs(o) do
         if type(k) ~= 'number' then k = '"'..k..'"' end
         s = s .. '['..k..'] = ' .. dump(v) .. ',\n'
      end
      return s .. '} '
   else
      return tostring(o)
   end
end



function world2tile (x)
	return math.floor((x/TILESIZE)+0.5)
end

function tile2world (x)
	return x*TILESIZE
end


function rectOverlap(x1,y1,w1,h1,  x2,y2,w2,h2)
  return x1 < x2+w2 and
         x2 < x1+w1 and
         y1 < y2+h2 and
         y2 < y1+h1
end

function pointInRect (x,y,  x1,y1, x2,y2)
    if (x > x1 and x < x2 and y > y1 and y < y2) then
        return true
    else
        return false
    end
end

--arg contains only the program path? WTF
function snil (...)
	local s = "x"
	for i,v in ipairs(arg) do
        if v then
			if type(v) == "number" then v = v end-- math.floor(v) end
			
		else
			v = "nil"
		
      end
              s=s..v.."/"

    end
	return s
end
