
--no clipping bugs. sticky when hitting wall and trying to move diagonal
function updatePlayersPhysics (dt)
	local speed = 100
	local m=speed*dt
	local dirx=0
	local diry=0
	for i,p in ipairs(gplayers) do
		p.tx=world2tile(p.x)
		p.ty=world2tile(p.y)
		p.tox=p.tx
		p.toy=p.ty
		local newx=p.x
		local newy=p.y
		--[[
		if p.wantLeft then newx = p.x -m dirx=-1 end
		if p.wantRight then newx = p.x +m dirx=1 end
		if p.wantUp then newy = p.y -m diry=-1 end
		if p.wantDown then newy = p.y +m diry=1 end
		if level.tile[world2tile (newx+dirx*PLAYERRADIUS)][world2tile(newy+diry*PLAYERRADIUS)].block == false
		and level.tile[world2tile (newx+dirx*PLAYERRADIUS)][world2tile(newy)].block == false
		and level.tile[world2tile (newx)][world2tile(newy+diry*PLAYERRADIUS)].block == false then
		--]]
		local wx=0
		local wy=0
		if p.wantLeft then p.tox = p.tx-1 wx=true end
		if p.wantRight then p.tox = p.tx+1 wy=true end
		if p.wantUp then p.toy = p.ty-1 wy=true end
		if p.wantDown then p.toy = p.ty+1 wy=true end	
		if wx then
			newx=newx+(p.tox - p.tx)*m
		end
		if wy then
			newy=newy+(p.toy - p.ty)*m
		end
		local dirx=(p.tox - p.tx)
		local diry=(p.toy - p.ty)
		if level.tile[world2tile (newx+dirx*PLAYERRADIUS)][world2tile(newy+diry*PLAYERRADIUS)].block == false
		and level.tile[world2tile (newx+dirx*PLAYERRADIUS)][world2tile(newy)].block == false
		and level.tile[world2tile (newx)][world2tile(newy+diry*PLAYERRADIUS)].block == false 
		and level.tile[world2tile (newx+dirx*PLAYERRADIUS)][world2tile(newy+PLAYERRADIUS)].block == false
		and level.tile[world2tile (newx+dirx*PLAYERRADIUS)][world2tile(newy-PLAYERRADIUS)].block == false
		and level.tile[world2tile (newx+PLAYERRADIUS)][world2tile(newy+diry*PLAYERRADIUS)].block == false 
		and level.tile[world2tile (newx-PLAYERRADIUS)][world2tile(newy+diry*PLAYERRADIUS)].block == false then

		
			p.x=newx
			p.y=newy
		end
		
		--end
	end
end


--slide along walls when moving diagonally. clip half into tile when hitting corner/edge
function updatePlayersPhysics2 (dt)
	local speed = 100
	local m=speed*dt

	for i,p in ipairs(gplayers) do
		p.tx=world2tile(p.x)
		p.ty=world2tile(p.y)
		p.tox=p.tx
		p.toy=p.ty
		local newx=p.x
		local newy=p.y
	local dirx=0
	local diry=0
		--[[
		if p.wantLeft then newx = p.x -m dirx=-1 end
		if p.wantRight then newx = p.x +m dirx=1 end
		if p.wantUp then newy = p.y -m diry=-1 end
		if p.wantDown then newy = p.y +m diry=1 end
		if level.tile[world2tile (newx+dirx*PLAYERRADIUS)][world2tile(newy+diry*PLAYERRADIUS)].block == false
		and level.tile[world2tile (newx+dirx*PLAYERRADIUS)][world2tile(newy)].block == false
		and level.tile[world2tile (newx)][world2tile(newy+diry*PLAYERRADIUS)].block == false then
		--]]
		local wx=0
		local wy=0
		if p.wantLeft then dirx=-1 wx=true end
		if p.wantRight then dirx=1 wy=true end
		if p.wantUp then diry=-1 wy=true end
		if p.wantDown then diry=1 wy=true end	
		if wx then
			newx=newx+dirx*m
		end
		if wy then
			newy=newy+diry*m
		end
		--local dirx=(p.tox - p.tx)
		--local diry=(p.toy - p.ty)
		local allowX=true
		local allowY=true
		if  isBlock(level, world2tile (newx),world2tile(newy+diry*PLAYERRADIUS)) then 
			allowY=false
		end
		if  isBlock(level, world2tile (newx+dirx*PLAYERRADIUS),world2tile(newy)) then 
			allowX=false
		end
		
	---	rectOverlap (p.x,p.y,PLAYERRADIUS,PLAYERRADIUS,  world2tile(newx),world2tile(newy), TILESIZE,TILESIZE)
		
	--	if level.tile[world2tile (newx+dirx*PLAYERRADIUS)][world2tile(newy+diry*PLAYERRADIUS)].block == false
	--	and level.tile[world2tile (newx+dirx*PLAYERRADIUS)][world2tile(newy)].block == false
--		and level.tile[world2tile (newx)][world2tile(newy+diry*PLAYERRADIUS)].block == false 
	--	and level.tile[world2tile (newx+dirx*PLAYERRADIUS)][world2tile(newy+PLAYERRADIUS)].block == false
	--	and level.tile[world2tile (newx+dirx*PLAYERRADIUS)][world2tile(newy-PLAYERRADIUS)].block == false
	--	and level.tile[world2tile (newx+PLAYERRADIUS)][world2tile(newy+diry*PLAYERRADIUS)].block == false 
	--	and level.tile[world2tile (newx-PLAYERRADIUS)][world2tile(newy+diry*PLAYERRADIUS)].block == false then
--then
		
		if allowX then p.x=newx end
		if allowY then p.y=newy end
		--end
		
		--end
	end
end
